package betterwithmods.common.items;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockPlanter;
import betterwithmods.common.blocks.BlockPlanter.EnumType;
import net.minecraft.block.Block;
import net.minecraft.block.BlockFarmland;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.common.IPlantable;

import javax.annotation.Nonnull;

public class ItemFertilizer extends Item {
    public ItemFertilizer() {
        super();

    }

    public static boolean processBlock(Block block, World world, BlockPos pos) {
        if (block == Blocks.field_150458_ak) {
            world.func_175656_a(pos, BWMBlocks.FERTILE_FARMLAND.func_176223_P().func_177226_a(BlockFarmland.field_176531_a, world.func_180495_p(pos).func_177229_b(BlockFarmland.field_176531_a)));
            world.func_175718_b(2005, pos.func_177984_a(), 0);
            return true;
        } else if (block == BlockPlanter.BLOCKS.get(EnumType.FARMLAND) && block.func_176201_c(world.func_180495_p(pos)) == 1) {
            world.func_175656_a(pos, BlockPlanter.BLOCKS.get(EnumType.FERTILE).func_176223_P());
            world.func_175718_b(2005, pos.func_177984_a(), 0);
            return true;
        }
        return false;
    }

    @Nonnull
    @Override
    public EnumActionResult func_180614_a(EntityPlayer player, World world, BlockPos pos, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        ItemStack stack = player.func_184586_b(hand);
        Block block = world.func_180495_p(pos).func_177230_c();
        if (block instanceof IPlantable) {
            Block below = world.func_180495_p(pos.func_177977_b()).func_177230_c();
            if (processBlock(below, world, pos.func_177977_b())) {
                if (!player.field_71075_bZ.field_75098_d)
                    stack.func_190918_g(1);
                return EnumActionResult.SUCCESS;
            }
        } else if (processBlock(block, world, pos)) {
            if (!player.field_71075_bZ.field_75098_d)
                stack.func_190918_g(1);
            return EnumActionResult.SUCCESS;
        }
        return EnumActionResult.PASS;
    }
}
