package betterwithmods.client.container.anvil;

import betterwithmods.common.tile.TileSteelAnvil;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.InventoryCraftResult;
import net.minecraft.item.ItemStack;
import net.minecraft.util.SoundCategory;

import javax.annotation.Nonnull;

public class InventorySteelCraftingResult extends InventoryCraftResult {

    private final TileSteelAnvil craft;

    public InventorySteelCraftingResult(TileSteelAnvil te) {
        craft = te;
    }

    @Nonnull
    @Override
    public ItemStack func_70301_a(int slot) {
        return slot == 0 ? craft.getResult() : null;
    }

    @Nonnull
    @Override
    public ItemStack func_70298_a(int slot, int decrement) {
        //return craft.decrStackSize(slot, decrement);
        craft.func_145831_w().func_184133_a(null, craft.func_174877_v(), SoundEvents.field_187698_i, SoundCategory.BLOCKS, 0.5f, 1.0f);
        ItemStack stack = craft.getResult();
        if (stack != null) {
            craft.setResult(null);
            return stack;
        } else {
            return null;
        }
    }

    @Override
    public void func_70299_a(int slot, @Nonnull ItemStack stack) {
        craft.setResult(stack);
    }
}
